clc

%set voltage range for extracting data
v_mid = 0;
v_min = v_mid-0.025;
v_max = v_mid+0.025;

% load data file
IV_data = xlsread('IV_PERC_STC.xlsx');
vmeas= IV_data(:,1); %array of V from IV curve
imeas= IV_data(:,2);  %array of I from IV curve

%extract data in the selected voltage range
index_v_first = find( vmeas > v_min, 1 );
index_v_last = find( vmeas > v_max, 1 );
v_fit_sh = vmeas(index_v_first:index_v_last);
i_fit_sh = imeas(index_v_first:index_v_last);

%linear fit of IV data
P = polyfit(v_fit_sh,i_fit_sh,1);
slope = P(1); intercept = P(2);
yfit = P(1)*v_fit_sh+P(2);  % P(1) is the slope and P(2) is the intercept

%plot data along with fit
close all
plot(v_fit_sh,i_fit_sh,'x')
hold on
plot(v_fit_sh,yfit,'r-.')
set(gca,'FontSize',10)
xlabel('Voltage (V)','FontSize',12) 
ylabel('Current (A)','FontSize',12)
exportgraphics(gcf,'Rsh_SHJ.png','Resolution',200)

%determine shunt resistance value in Ohm from the slope of the linear fit
Rsh = 1/slope

